/******************************************************************************

    Filename:         codes.h

    Author:           Evan Weststrate

    Creation date:    28 January 2000

    Contents:         codes for the gates, etc.


                          *** DOCUMENTATION ***
Subtypes implemented:
-transistor
-gate
-memory
-behavioral
 

 ******************************************************************************/

class typecode
{
public:
	typecode(int);	//constructor
	~typecode(){}
	char* getName() {return itsName;}
private:
	char* itsName;
};

class transistorcode
{
public:
	transistorcode(int);  //constructor
	~transistorcode(){}
	char* getName() {return itsName;}  //member function to get the name.
private:
	char* itsName;
};

class gatecode
{
public:
	gatecode(int);  //constructor
	~gatecode(){}
	char* getName() {return itsName;}  //member function to get the name.
private:
	char* itsName;
};

class memorycode
{
public:
	memorycode(int);  //constructor
	~memorycode(){}
	char* getName() {return itsName;}  //member function to get the name.
private:
	char* itsName;
};

class behavioralcode
{
public:
	behavioralcode(int);  //constructor
	~behavioralcode(){}
	char* getName() {return itsName;}  //member function to get the name.
private:
	char* itsName;
};

class positioncode
{
public:
	positioncode(int);	//constructor
	~positioncode(){}
	char* getName() {return itsName;}
private:
	char* itsName;
};

typecode::typecode(int num)
{
	switch (num)
	{
	case  0:	itsName = "NODE"; break;
	case  1:	itsName = "WIRE"; break;
	case  2:	itsName = "REGISTER"; break;
	case  3:	itsName = "CONST"; break;
	case  4:	itsName = "TRANSISTOR"; break;
	case  5:	itsName = "GATE"; break;
	case  6:	itsName = "MEMORY"; break;
	case  7:	itsName = "PROCESS"; break;
	case  8:	itsName = "RT_ASSIGNEMENT"; break;
	case  9:	itsName = "RT_CONDITION"; break;
	case 10:	itsName = "RT_CONTROL"; break;
	case 11:	itsName = "RT_LOAD"; break;
	case 12:	itsName = "ASSTRIG"; break;
	case 13:	itsName = "BIT_EXTRACT"; break;
	case 14:	itsName = "ASSTRIG_CNTRL"; break;
	case 15:	itsName = "BEHAVIORAL"; break;

	default:	itsName = "Unknown Type";
	}
}

gatecode::gatecode(int num)
{
	switch (num)
	{
	case  0:	itsName = "AND";	break;
	case  1:	itsName = "NAND"; break;
	case  2:	itsName = "OR"; break;
	case  3:	itsName = "NOR"; break;
	case  4:	itsName = "BUF"; break;
	case  5:	itsName = "INV"; break;
	case  6:	itsName = "AND_TRI"; break;
	case  7:	itsName = "NAND_TRI"; break;
	case  8:	itsName = "OR_TRI"; break;
	case  9:	itsName = "NOR_TRI"; break;
	case 10:	itsName = "BUF_TRI"; break;
	case 11:	itsName = "INV_TRI"; break;
	case 12:	itsName = "AND_TRIN"; break;
	case 13:	itsName = "NAND_TRIN"; break;
	case 14:	itsName = "OR_TRIN"; break;
	case 15:	itsName = "NOR_TRIN"; break;
	case 16:	itsName = "BUF_TRIN"; break;
	case 17:	itsName = "INV_TRIN"; break;
	case 18:	itsName = "AND_OC"; break;
	case 19:	itsName = "NAND_OC"; break;
	case 20:	itsName = "OR_OC"; break;
	case 21:	itsName = "NOR_OC"; break;
	case 22:	itsName = "BUF_OC"; break;
	case 23:	itsName = "INV_OC"; break;
	case 24:	itsName = "AND_OE"; break;
	case 25:	itsName = "NAND_OE"; break;
	case 26:	itsName = "OR_OE"; break;
	case 27:	itsName = "NOR_OE"; break;
	case 28:	itsName = "BUF_OE"; break;
	case 29:	itsName = "INV_OE"; break;
	case 30:	itsName = "XOR"; break;
	case 31:	itsName = "XNOR"; break;
	case 32:	itsName = "MUX"; break;
	case 33:	itsName = "SRNOR"; break;
	case 34:	itsName = "SRNAND"; break;
	case 35:	itsName = "TGP"; break;
	case 36:	itsName = "TGN"; break;
	case 37:	itsName = "MTGP"; break;
	case 38:	itsName = "MTGN"; break;
	case 39:	itsName = "BUS_TRI"; break;
	case 40:	itsName = "BUS_MOS"; break;
	case 41:	itsName = "BUS_UP"; break;
	case 42:	itsName = "BUS_DOWN"; break;
//flip-flop codes  
	case 43:	itsName = "JKBLOCK"; break;
	case 44:	itsName = "DFF_PET"; break;
	case 45:	itsName = "TFF_PET"; break;
	case 46:	itsName = "JKFF_PET"; break;
	case 47:	itsName = "DFF_PET_C"; break;
	case 48:	itsName = "TFF_PET_C"; break;
	case 49:	itsName = "JKFF_PET_C"; break;
	case 50:	itsName = "DFF_PET_S"; break;
	case 51:	itsName = "TFF_PET_S"; break;
	case 52:	itsName = "JKFF_PET_S"; break;
	case 53:	itsName = "DFF_PET_SC"; break;
	case 54:	itsName = "TFF_PET_SC"; break;
	case 55:	itsName = "JKFF_PET_SC"; break;
	case 56:	itsName = "DFF_NET"; break;
	case 57:	itsName = "TFF_NET"; break;
	case 58:	itsName = "JKFF_NET"; break;
	case 59:	itsName = "DFF_NET_C"; break;
	case 60:	itsName = "TFF_NET_C"; break;
	case 61:	itsName = "JKFF_NET_C"; break;
	case 62:	itsName = "DFF_NET_S"; break;
	case 63:	itsName = "TFF_NET_S"; break;
	case 64:	itsName = "JKFF_NET_S"; break;
	case 65:	itsName = "DFF_NET_SC"; break;
	case 66:	itsName = "TFF_NET_SC"; break;
	case 67:	itsName = "JKFF_NET_SC"; break;
	case 68:	itsName = "LATCH_HIGH"; break;
	case 69:	itsName = "LATCH_LOW"; break;

	default:	itsName = "Gate Unknown";
	}
}
//user behavioral codes  
behavioralcode::behavioralcode(int num)
{
	switch (num)
	{
	case  1:	itsName = "HALF_ADDER"; break;
	case  2:	itsName = "FULL_ADDER"; break;
	case  3:	itsName = "RING_BUFFER"; break;
	case  4:	itsName = "4TO1_MUX"; break;
	case  5:	itsName = "S27"; break;
        case  6:	itsName = "VIPER_ALU"; break;
        case  7:	itsName = "VIPER_CONTROL"; break;
        case  8:	itsName = "VIPER_REGS"; break;
        case  9:	itsName = "DUMB_ALU"; break;
        case 10:	itsName = "MATTI_MUX"; break;
        case 11:	itsName = "MEMS_PSENSOR"; break;

	default:	itsName = "Behavior Unknown";
	}
}

positioncode::positioncode(int num)
{
	switch (num)
	{
	case  0:	itsName = "INTERNAL"; break;
	case  1:	itsName = "INPUT"; break;
	case  2:	itsName = "OUTPUT"; break;
	case  3:	itsName = "BIDIRECTIONAL"; break;
	case  4:	itsName = "PHANTOM"; break;

	default:	itsName = "Position Unknown";
	}
}

transistorcode::transistorcode(int num)  
{
  switch (num)
    {
    case 0:  itsName = "DEPLETION"; break;
    case 1:  itsName = "N_CHANNEL 1"; break;
    case 2:  itsName = "P_CHANNEL 2"; break;

    default: itsName = "Transistor Unknown";
    }
}

memorycode::memorycode(int num)  
{
  switch (num)
    {
    case 0:  itsName = "PLA"; break;
    case 1:  itsName = "RAM"; break;
    case 2:  itsName = "ROM"; break;

    default: itsName = "Memory Unknown";
    }
}

